
#include <pspkernel.h>
#include <pspdebug.h> 
#include <pspctrl.h>

/*ģϢ,汾*/
PSP_MODULE_INFO("Subject-04", 0, 1, 1); 

//߳,
PSP_MAIN_THREAD_ATTR(THREAD_ATTR_USER | THREAD_ATTR_VFPU);

//ѭ
int done = 0;

//д
#define printf pspDebugScreenPrintf

/*ûHomeĻص,ֿ㶨,Ὣúעᵽ˳ص*/
// Exit callback
int exit_callback(int arg1, int arg2, void *common)
{
      done = 1;
      return 0;
}

/*صִ߳еĺ,,Ὣøú̸߳ӵ߳*/
// Callback thread
int CallbackThread(SceSize args, void *argp)
{
      int cbid;
	  
	  //һΪexit callbackĻص,һεľ
      cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
	  //صעΪ˳ص
      sceKernelRegisterExitCallback(cbid);
	  
	  //߳˯,û˳ʱ
      sceKernelSleepThreadCB();

      return 0;
}

/*ûص̺߳ͷ߳id*/
// Sets up the callback thread and returns its thread id
int SetupCallbacks(void)
{
      int thid = 0;
		
	  //һΪupdate_thread߳
      thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0);
      if(thid >= 0) 
      {
			//update_thread̸߳ӵʼ߳
            sceKernelStartThread(thid, 0, 0);
      }

      return thid;
} 

int main()
{ 
	SceCtrlData pad;//ṹ,ǰ״̬
	pspDebugScreenInit();//ʼdebug screen
	SetupCallbacks(); //ûص߳
	
	sceCtrlSetSamplingCycle(0);//״̬,Ĭ0
	
	/* ģʽ ֣PSP_CTRL_MODE_DIGITALȣPSP_CTRL_MODE_ANALOG õȵ */
    sceCtrlSetSamplingMode(PSP_CTRL_MODE_ANALOG);
	while(!done) {
		pspDebugScreenSetXY(0, 2);//ùλ
		sceCtrlReadBufferPositive(&pad, 1); //ȡû
		/* ҡ˵*/
		pspDebugScreenPrintf("Analog X = %d ", pad.Lx);
		pspDebugScreenPrintf("Analog Y = %d  ", pad.Ly);
		//ĻϢ,printfһ,ڳʼdebugscreenʹ
		//pspDebugScreenPrintf("Hello PSP"); 
		
		 /* жϣĸӦ֣ú궼ʾˣֿԿ*/
        if (pad.Buttons != 0){
            if (pad.Buttons & PSP_CTRL_SQUARE){
                printf("Square pressed  ");
            }
            if (pad.Buttons & PSP_CTRL_TRIANGLE){
                printf("Triangle pressed  ");
            } 
            if (pad.Buttons & PSP_CTRL_CIRCLE){
                printf("Cicle pressed  ");
            } 
            if (pad.Buttons & PSP_CTRL_CROSS){
                printf("Cross pressed  ");
            } 
            if (pad.Buttons & PSP_CTRL_UP){
                printf("Up pressed  ");
            } 
            if (pad.Buttons & PSP_CTRL_DOWN){
                printf("Down pressed  ");
            } 
            if (pad.Buttons & PSP_CTRL_LEFT){
                printf("Left pressed  ");
            } 
            if (pad.Buttons & PSP_CTRL_RIGHT){
                printf("Right pressed  ");
            }      

            if (pad.Buttons & PSP_CTRL_START){
                printf("Start pressed  ");
            }
            if (pad.Buttons & PSP_CTRL_SELECT){
                printf("Select pressed  ");
            }
            if (pad.Buttons & PSP_CTRL_LTRIGGER){
                printf("L-trigger pressed  ");
            }
            if (pad.Buttons & PSP_CTRL_RTRIGGER){
                printf("R-trigger pressed  ");
            }
		}
	}
	sceKernelExitGame(); //˳Ϸ
	return 0; 
} 
